﻿using System;
using System.Threading;

namespace VirtualProxy
{
    class VirtualConverter : IConvert
    {
        ImageConverter realconverter = new ImageConverter();
        Thread thread = null;
        public string Image
        {
            get
            {
                return realconverter.Image;
            }
            set
            {
                realconverter.Image = value;
            }
        }
        public VirtualConverter()
        {
            Image = string.Empty;
        }
        public void ClearImage()
        {
            Image = string.Empty;
        }

        public string ConvertImage()
        {
            if (thread == null)
            {
                ThreadStart threadDelegate = new ThreadStart(RealConvert);
                thread = new Thread(threadDelegate);
                thread.Start();
                return "변환을 시작하였습니다.";
            }
            return "이미 변환 작업을 요청하여 수행하고 있는 중입니다.";           
            
        }
        void RealConvert()
        {
            realconverter.ConvertImage();
            Console.WriteLine("변환 작업을 완료하였습니다.");
            thread = null;

        }
        
    }
}
